pro bbsoprin,dim,imsize,printfile,header,filename
;##############################################
;# TO PRINT A FILE WITH SOME HEADER INFORMATION
;# by: Jamey Bass & Anders Johannesson
;##############################################

  ;# SAVE OLD DEVICE
  olddev=!d.name

  ;# GET IMAGE FROM SCREEN
  out=tvrd(0,imsize(1)-dim(2)-1,dim(1),dim(2))
  tvlct,r,g,b,/get
  out=g(out)       ;# USE LUT FOR B/W
  out=byte(round( (float(out)/229.0*255.0)>0<255 ))

  ;# PRINT IMAGE
  set_plot,'ps'
  xsize=15.0
  ysize=float(dim(2))/float(dim(1))*xsize
  device,file=printfile,bits=8,/palatino,xoffset=0,yoffset=0
  tv,out,/centimeters,(((21.25)/2.0)$
        -(xsize)/2.0),(((27.5)/2.0)-(ysize)/2.0)+1,xsize=xsize

  ;# GET HEADER INFORMATION (IF ANY)
  ra1='N/A' & de1='N/A' & date='N/A' & time='N/A'  ;# defaults to null
  if n_elements(header) gt 1 then begin
     for i=0,N_ELEMENTS(header)-1 do begin
        if strpos(header(i),'CRVAL1') ne (-1) then begin
           indata=fix((strmid(header(i),9,22)))
           ra1=string(format='(I4.1)',indata)
        endif
        if strpos(header(i),'CRVAL2') ne (-1) then begin
           indata=fix((strmid(header(i),9,22)))
           de1=string(format='(I4.1)',indata)
        endif
        if strpos(header(i),'DATE-OBS') ne (-1) then begin
           date=(strmid(header(i),11,8))
        endif
        if strpos(header(i),'TIME-OBS') ne (-1) then begin
           time=(strmid(header(i),11,8))
        endif
     end
  endif

  ;# PRINT HEADER INFORMATION
  xyouts,0.1,0.1+0.00,'RA: '+ra1+'   DEC: '+de1,/normal,font=0,size=1.0
  xyouts,0.1,0.1+0.04,'obs-date: '+date+'   obs-time: '+time,/normal,font=0,size=1.0
  xyouts,0.1,0.1+0.08,'Filename:  '+filename,/normal,font=0,size=1.0
  xyouts,0.1,0.1+0.12,'Printed by BBSOFITS '+systime(0),/normal,font=0,size=1.0

  ;# CLOSE THIS DEVICE AND RESET DEVICE
  device,/close
  set_plot,olddev

end