 pro bbsoread,intitle
 ;# FITS & JPEG READER FOR BBSOFITS USING: readfits.pro AND read_jpeg.pro
 ;# by Anders Johannesson & Scot Kleinman 1996
 
   COMMON IMDATA,im,imlast,header,oheader,imsize,contrast,ocontrast,dim,filename,$
         outname, helpfile, selection,oselection,traceplot,saveflag

   COMMON IMAGETEXT_Comm, IMAGETEXT

    WIDGET_CONTROL, /HOURGLASS
    old=filename

    ;# PICK FILE IN DIFFERENT OS
    a=!version & ver_no=fix(strmid(a.release,0,1))
    if ver_no gt 3 then begin
       if strpos(!version.os_family,'Windows') ne -1 then begin
          filename=pickfile(GET_PATH=newpath,FILTER = ['*.fts','*.fit','*.jpg'], $
                            TITLE=intitle)
       endif else begin
          filename=pickfile(GET_PATH=newpath,FILTER = ['*.fts *.fit *.jpg'], $
                            TITLE=intitle)
       endelse
    endif else begin
       filename=pickfile(GET_PATH=newpath,FILTER = ['*.fts','*.fit','*.jpg'], $
                         TITLE=intitle)
    endelse
    str_start=strlen(newpath)
    str_length=strlen(filename)-str_start
    filename=strmid(filename,str_start,str_length)
    filename=strlowcase(filename)
    if strlen(filename) gt 1 then begin
       WIDGET_CONTROL, /HOURGLASS
       cd,newpath
       extension=strmid(filename,rstrpos(filename,'.')+1,3)
       if (extension eq 'fts') or (extension eq 'fit') then begin
          im=readfits(filename,header,/SILENT,/NOSCALE)
          saveflag=1
          imlast=im
          dim=size(im)
          ;# RESET SELECTION
          p1=[0.0,0.0+(imsize(1)-dim(2))]
          p2=[dim(1)-1,(dim(2)-1)+(imsize(1)-dim(2))]
          selection=fill_select(0.0,0.0,p1,p2,p1)
          oselection=selection
          ;# CONVERT BYTE INTO SHORTWORD
          if dim(3) eq 1 then im=fix(im)
          pim=im(40:dim(1)-41,40:dim(2)-41)
          contrast=[long(min(pim)),long(max(pim))]
          ocontrast=contrast
          erase
          tv,bytscl(im,contrast(0),contrast(1)),0,imsize(1)-dim(2)
          loadct,0
          WIDGET_CONTROL, IMAGETEXT, set_value=[' '+$
          strmid(filename,rstrpos(filename,'\')+1,99),$
          ' '+string(format='(I4.0)',$
          dim(1))+' x '+string(format='(I4.0)',dim(2))+' (FITS)']
       endif
       if (extension eq 'jpg') then begin
          read_jpeg,filename,im
          ;# IF COLOR JPEG USE ONLY GREEN CHANNEL ###
          dim=size(im)
          if dim(0) eq 3 then im=reform(im(1,*,*))
          ;##########################################
          saveflag=1
          header='NO HEADER - image was read as JPEG'
          imlast=im
          dim=size(im)
          ;# RESET SELECTION
          p1=[0.0,0.0+(imsize(1)-dim(2))]
          p2=[dim(1)-1,(dim(2)-1)+(imsize(1)-dim(2))]
          selection=fill_select(0.0,0.0,p1,p2,p1)
          oselection=selection
          ;# MAKE BYTE SHORTWORD
          if dim(3) eq 1 then im=fix(im)
          pim=im(40:dim(1)-41,40:dim(2)-41)
          contrast=[long(min(pim)),long(max(pim))]
          ocontrast=contrast
          erase
          tv,bytscl(im,contrast(0),contrast(1)),0,imsize(1)-dim(2)
          loadct,0
          WIDGET_CONTROL, IMAGETEXT, set_value=[' '+$
          strmid(filename,rstrpos(filename,'\')+1,99),$
          ' '+string(format='(I4.0)',$
          dim(1))+' x '+string(format='(I4.0)',dim(2))+' (JPEG)']
       endif
    endif else begin
       if strlen(old) gt 1 then begin
          filename=old
       endif else begin
          WIDGET_CONTROL, IMAGETEXT, set_value=' No image loaded'
       endelse
    endelse
end
	
	